(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('mw-form-builder', ['exports', '@angular/core', '@angular/forms', '@angular/common'], factory) :
    (factory((global['mw-form-builder'] = {}),global.ng.core,global.ng.forms,global.ng.common));
}(this, (function (exports,core,ng,common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/abstract-form-field/abstract-form-field.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     * @template T
     */
    var AbstractFormFieldComponent = /** @class */ (function () {
        function AbstractFormFieldComponent() {
        }
        AbstractFormFieldComponent.propDecorators = {
            mwFormGroup: [{ type: core.Input }],
            mwElement: [{ type: core.Input }],
            mwIndex: [{ type: core.Input }],
            mwFieldType: [{ type: core.Input }],
            mwPath: [{ type: core.Input }],
            mwSlots: [{ type: core.Input }]
        };
        return AbstractFormFieldComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/form-type/abstract-type.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     * @template T
     */
    var /**
     * @abstract
     * @template T
     */ AbstractType = /** @class */ (function () {
        function AbstractType(options) {
            this.options = options;
        }
        Object.defineProperty(AbstractType.prototype, "asyncValidators", {
            get: /**
             * @return {?}
             */ function () {
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractType.prototype, "validators", {
            get: /**
             * @return {?}
             */ function () {
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractType.prototype, "updateOn", {
            get: /**
             * @return {?}
             */ function () {
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractType.prototype, "disabled", {
            get: /**
             * @return {?}
             */ function () {
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractType.prototype, "controlOptions", {
            get: /**
             * @return {?}
             */ function () {
                return {
                    asyncValidators: this.asyncValidators,
                    validators: this.validators,
                    updateOn: this.updateOn
                };
            },
            enumerable: true,
            configurable: true
        });
        return AbstractType;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/form-type/abstract-collection-type.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     * @template TConfig, T
     */
    var /**
     * @abstract
     * @template TConfig, T
     */ AbstractCollectionType = /** @class */ (function (_super) {
        __extends(AbstractCollectionType, _super);
        // noinspection TypeScriptAbstractClassConstructorCanBeMadeProtected
        function AbstractCollectionType(childType, options) {
            var _this = _super.call(this, options) || this;
            _this.childType = childType;
            _this.fieldInstance = new _this.childType(_this.options.entrySettings);
            return _this;
        }
        return AbstractCollectionType;
    }(AbstractType));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/form-type/abstract-group-type.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     * @template T
     */
    var /**
     * @abstract
     * @template T
     */ AbstractGroupType = /** @class */ (function (_super) {
        __extends(AbstractGroupType, _super);
        function AbstractGroupType() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return AbstractGroupType;
    }(AbstractType));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/abstraction/init-handler.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var /**
     * @template T
     */ InitHandler = /** @class */ (function () {
        function InitHandler(instance) {
            this.instance = instance;
            this.propIsInitialized = false;
        }
        Object.defineProperty(InitHandler.prototype, "isInitialized", {
            get: /**
             * @return {?}
             */ function () {
                return this.propIsInitialized;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} value
         * @return {?}
         */
        InitHandler.prototype.setIsInitialized = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                /** @type {?} */
                var isGroupOrArray = 'controls' in this.instance;
                this.propIsInitialized = value;
                if (isGroupOrArray) {
                    (( /** @type {?} */(( /** @type {?} */(this.instance)))))._setUpControls();
                }
                this.instance.updateValueAndValidity({ onlySelf: false, emitEvent: true });
                if (isGroupOrArray) {
                    /** @type {?} */
                    var childControls_1 = (( /** @type {?} */(this.instance))).controls;
                    Object.keys(childControls_1)
                        .forEach(( /**
                 * @param {?} k
                 * @return {?}
                 */function (k) { return childControls_1[k].initHandler.setIsInitialized(value); }));
                }
            };
        return InitHandler;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/abstraction/form-array.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormArray = /** @class */ (function (_super) {
        __extends(FormArray, _super);
        function FormArray() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.initHandler = new InitHandler(_this);
            return _this;
        }
        /**
         * @param {?=} opts
         * @return {?}
         */
        FormArray.prototype.updateValueAndValidity = /**
         * @param {?=} opts
         * @return {?}
         */
            function (opts) {
                if (this.initHandler && this.initHandler.isInitialized) {
                    _super.prototype.updateValueAndValidity.call(this, opts);
                }
            };
        return FormArray;
    }(ng.FormArray));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/abstraction/form-control.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormControl = /** @class */ (function (_super) {
        __extends(FormControl, _super);
        function FormControl() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.initHandler = new InitHandler(_this);
            return _this;
        }
        /**
         * @param {?=} opts
         * @return {?}
         */
        FormControl.prototype.updateValueAndValidity = /**
         * @param {?=} opts
         * @return {?}
         */
            function (opts) {
                if (this.initHandler && this.initHandler.isInitialized) {
                    _super.prototype.updateValueAndValidity.call(this, opts);
                }
            };
        return FormControl;
    }(ng.FormControl));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/abstraction/form-group.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormGroup = /** @class */ (function (_super) {
        __extends(FormGroup, _super);
        function FormGroup() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.initHandler = new InitHandler(_this);
            return _this;
        }
        /**
         * @param {?=} opts
         * @return {?}
         */
        FormGroup.prototype.updateValueAndValidity = /**
         * @param {?=} opts
         * @return {?}
         */
            function (opts) {
                if (this.initHandler && this.initHandler.isInitialized) {
                    _super.prototype.updateValueAndValidity.call(this, opts);
                }
            };
        return FormGroup;
    }(ng.FormGroup));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/abstraction/index.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/form-type/abstract-layout-type.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     * @template T
     */
    var /**
     * @abstract
     * @template T
     */ AbstractLayoutType = /** @class */ (function (_super) {
        __extends(AbstractLayoutType, _super);
        function AbstractLayoutType() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return AbstractLayoutType;
    }(AbstractGroupType));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/model-handler.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ModelHandler = /** @class */ (function () {
        function ModelHandler() {
        }
        /**
         * @param {?} model
         * @param {?} builderInstance
         * @return {?}
         */
        ModelHandler.build = /**
         * @param {?} model
         * @param {?} builderInstance
         * @return {?}
         */
            function (model, builderInstance) {
                /** @type {?} */
                var group = new FormGroup({});
                this.handleModel(model, group, builderInstance);
                return group;
            };
        /**
         * @private
         * @param {?} model
         * @param {?} group
         * @param {?} builderInstance
         * @return {?}
         */
        ModelHandler.handleModel = /**
         * @private
         * @param {?} model
         * @param {?} group
         * @param {?} builderInstance
         * @return {?}
         */
            function (model, group, builderInstance) {
                var _this = this;
                Object.keys(model).forEach(( /**
                 * @param {?} name
                 * @return {?}
                 */function (name) {
                    /** @type {?} */
                    var field = model[name];
                    if (!field) {
                        return;
                    }
                    if (field instanceof AbstractLayoutType) {
                        _this.handleModel(field.options.model, group, builderInstance);
                        return;
                    }
                    /** @type {?} */
                    var control = ModelHandler.buildSingleField(field, builderInstance);
                    if (!control) {
                        return;
                    }
                    control.setParent(group);
                    if (field.disabled) {
                        control.disable();
                    }
                    group.addControl(name, control);
                    if (field.builderInstance == null && builderInstance) {
                        field.builderInstance = builderInstance;
                    }
                    field.control = control;
                }));
            };
        /**
         * @param {?} field
         * @param {?} builderInstance
         * @return {?}
         */
        ModelHandler.buildSingleField = /**
         * @param {?} field
         * @param {?} builderInstance
         * @return {?}
         */
            function (field, builderInstance) {
                /** @type {?} */
                var component;
                if (field instanceof AbstractCollectionType) {
                    component = new FormArray([], field.controlOptions);
                    ModelHandler.handleArray(field, component, builderInstance);
                }
                else if (field instanceof AbstractGroupType) {
                    component = new FormGroup({}, field.controlOptions);
                    ModelHandler.handleModel(field.options.model, component, builderInstance);
                }
                else if (field instanceof AbstractLayoutType) ;
                else if (field instanceof AbstractType) {
                    component = new FormControl({ value: null, disabled: field.disabled }, field.controlOptions);
                }
                return component;
            };
        /**
         * @private
         * @param {?} field
         * @param {?} array
         * @param {?} builderInstance
         * @return {?}
         */
        ModelHandler.handleArray = /**
         * @private
         * @param {?} field
         * @param {?} array
         * @param {?} builderInstance
         * @return {?}
         */
            function (field, array, builderInstance) {
                /** @type {?} */
                var control = ModelHandler.buildSingleField(field.fieldInstance, builderInstance);
                if (!control) {
                    return;
                }
                array.push(control);
            };
        return ModelHandler;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/abstract-collection/abstract-collection.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // noinspection JSUnusedGlobalSymbols
    /**
     * @abstract
     */
    var AbstractCollectionComponent = /** @class */ (function (_super) {
        __extends(AbstractCollectionComponent, _super);
        function AbstractCollectionComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        // noinspection JSUnusedGlobalSymbols
        // noinspection JSUnusedGlobalSymbols
        /**
         * @param {?} index
         * @return {?}
         */
        AbstractCollectionComponent.prototype.removeEntry =
            // noinspection JSUnusedGlobalSymbols
            /**
             * @param {?} index
             * @return {?}
             */
            function (index) {
                this.mwElement.removeAt(index);
            };
        // noinspection JSUnusedGlobalSymbols
        // noinspection JSUnusedGlobalSymbols
        /**
         * @return {?}
         */
        AbstractCollectionComponent.prototype.addEntry =
            // noinspection JSUnusedGlobalSymbols
            /**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var newControl = ModelHandler.buildSingleField(this.mwFieldType.fieldInstance, this.mwFieldType.builderInstance);
                if (!newControl) {
                    return;
                }
                newControl.initHandler.setIsInitialized(true);
                this.mwElement.controls.push(newControl);
            };
        AbstractCollectionComponent.propDecorators = {
            mwElement: [{ type: core.Input }]
        };
        return AbstractCollectionComponent;
    }(AbstractFormFieldComponent));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/form-slot/form-slot.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormSlotDirective = /** @class */ (function () {
        function FormSlotDirective(viewRef) {
            this.viewRef = viewRef;
        }
        /**
         * @return {?}
         */
        FormSlotDirective.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                if (this.renderFn) {
                    this.renderFn(this.viewRef);
                }
            };
        /**
         * @param {?} renderFunction
         * @return {?}
         */
        FormSlotDirective.prototype.setup = /**
         * @param {?} renderFunction
         * @return {?}
         */
            function (renderFunction) {
                this.renderFn = renderFunction;
                if (this.viewRef) {
                    this.ngAfterViewInit();
                }
            };
        FormSlotDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[mwFormSlot]',
                        exportAs: 'mwFormSlot',
                    },] }
        ];
        /** @nocollapse */
        FormSlotDirective.ctorParameters = function () {
            return [
                { type: core.ViewContainerRef }
            ];
        };
        FormSlotDirective.propDecorators = {
            mwFieldName: [{ type: core.Input }]
        };
        return FormSlotDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/field-instance-helper.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FieldInstanceHelper = /** @class */ (function () {
        function FieldInstanceHelper() {
        }
        /**
         * @param {?} instance
         * @param {?} data
         * @return {?}
         */
        FieldInstanceHelper.setupFieldInstance = /**
         * @param {?} instance
         * @param {?} data
         * @return {?}
         */
            function (instance, data) {
                /** @type {?} */
                var changes = {
                    mwFormGroup: new core.SimpleChange(null, data.mwFormGroup, true),
                    mwElement: new core.SimpleChange(null, data.mwElement, true),
                    mwFieldType: new core.SimpleChange(null, data.mwFieldType, true),
                    mwSlots: new core.SimpleChange(null, data.mwSlots, true),
                    mwPath: new core.SimpleChange(null, data.mwPath, true),
                    mwIndex: new core.SimpleChange(null, data.mwIndex, true),
                };
                instance.mwFormGroup = changes.mwFormGroup.currentValue;
                instance.mwElement = changes.mwElement.currentValue;
                instance.mwFieldType = changes.mwFieldType.currentValue;
                instance.mwSlots = changes.mwSlots.currentValue;
                instance.mwPath = changes.mwPath.currentValue;
                instance.mwIndex = changes.mwIndex.currentValue;
                if ('ngOnChanges' in instance) {
                    (( /** @type {?} */(instance))).ngOnChanges(changes);
                }
            };
        return FieldInstanceHelper;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/abstract-form-group/abstract-form-group.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // noinspection JSUnusedGlobalSymbols
    /**
     * @abstract
     * @template FormType
     */
    var AbstractFormGroupComponent = /** @class */ (function (_super) {
        __extends(AbstractFormGroupComponent, _super);
        function AbstractFormGroupComponent(cfr, cdr) {
            var _this = _super.call(this) || this;
            _this.cfr = cfr;
            _this.cdr = cdr;
            _this.groupPath = '';
            _this.indexFromParent = null;
            _this.fieldPaths = {};
            _this.elements = {};
            _this.renderTargets = {};
            return _this;
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        AbstractFormGroupComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
            function (changes) {
                var _this = this;
                /** @type {?} */
                var mwPath = 'mwPath' in changes ? changes.mwPath.currentValue : this.mwPath;
                if ('mwPath' in changes) {
                    this.groupPath = (mwPath == null || mwPath.trim() === '')
                        ? ''
                        : mwPath;
                }
                /** @type {?} */
                var mwFieldType = 'mwFieldType' in changes ? changes.mwFieldType.currentValue : this.mwFieldType;
                if ('mwPath' in changes || 'mwFieldType' in changes) {
                    this.fieldPaths = Object.keys(mwFieldType.options.model).reduce(( /**
                     * @param {?} all
                     * @param {?} fieldName
                     * @return {?}
                     */function (all, fieldName) {
                        if (mwFieldType.options.model[fieldName] instanceof AbstractLayoutType) {
                            all[fieldName] = mwPath;
                        }
                        else {
                            all[fieldName] = (_this.groupPath !== '' ? _this.groupPath + '.' : '') + fieldName;
                        }
                        return all;
                    }), {});
                }
                if ('mwIndex' in changes) {
                    /** @type {?} */
                    var mwIndex = changes.mwIndex.currentValue;
                    this.indexFromParent = null;
                    if (mwIndex != null) {
                        /** @type {?} */
                        var p = this.mwElement;
                        do {
                            p = p.parent;
                            if (p instanceof FormArray) {
                                this.indexFromParent = this.mwIndex;
                                break;
                            }
                        } while (p && p.parent && !(parent instanceof FormControl));
                    }
                }
                this.elements = Object.keys(mwFieldType.options.model).reduce(( /**
                 * @param {?} all
                 * @param {?} fieldName
                 * @return {?}
                 */function (all, fieldName) {
                    if (mwFieldType.options.model[fieldName] instanceof AbstractLayoutType) {
                        all[fieldName] = _this.mwElement;
                    }
                    else {
                        all[fieldName] = _this.mwElement.get(fieldName);
                    }
                    return all;
                }), {});
                /** @type {?} */
                var wasRendered = false;
                if ('mwSlots' in changes && changes.mwSlots.currentValue) {
                    this.renderElementsInSlots();
                    wasRendered = true;
                }
                if (!wasRendered && 'mySlots' in changes && changes.mySlots.currentValue) {
                    this.renderElementsInSlots();
                }
            };
        /**
         * @return {?}
         */
        AbstractFormGroupComponent.prototype.ngAfterContentInit = /**
         * @return {?}
         */
            function () {
                if (this.mySlots) {
                    this.renderElementsInSlots();
                    this.cdr.detectChanges();
                }
            };
        /**
         * @private
         * @return {?}
         */
        AbstractFormGroupComponent.prototype.renderElementsInSlots = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                if (!(this.mwSlots || this.mySlots)) {
                    return;
                }
                this.createRenderTargets();
                Object.keys(this.renderTargets).forEach(( /**
                 * @param {?} name
                 * @return {?}
                 */function (name) {
                    if (!(name in _this.renderTargets)) {
                        return;
                    }
                    _this.renderTargets[name].setup(( /**
                     * @param {?} viewRef
                     * @return {?}
                     */function (viewRef) {
                        viewRef.clear();
                        /** @type {?} */
                        var factory = _this.cfr.resolveComponentFactory(_this.mwFieldType.options.model[name].component);
                        /** @type {?} */
                        var component = viewRef.createComponent(factory);
                        /** @type {?} */
                        var isGroup = _this.mwFieldType.options.model[name] instanceof AbstractGroupType;
                        FieldInstanceHelper.setupFieldInstance(component.instance, {
                            mwFormGroup: isGroup ? _this.elements[name] : _this.mwFormGroup,
                            mwElement: _this.elements[name],
                            mwFieldType: _this.mwFieldType.options.model[name],
                            mwSlots: _this.mwSlots,
                            mwPath: _this.fieldPaths[name],
                            mwIndex: _this.indexFromParent,
                        });
                    }));
                }));
                this.mwElement.initHandler.setIsInitialized(true);
                this.cdr.detectChanges();
            };
        /**
         * @private
         * @return {?}
         */
        AbstractFormGroupComponent.prototype.createRenderTargets = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var groupPath = this.groupPath;
                if (this.mwSlots) {
                    this.mwSlots.toArray().forEach(( /**
                     * @param {?} slot
                     * @return {?}
                     */function (slot) {
                        if (slot.mwFieldName.substr(0, groupPath.length) !== groupPath) {
                            return;
                        }
                        /** @type {?} */
                        var name = slot.mwFieldName.substr(groupPath.length, slot.mwFieldName.length - groupPath.length);
                        if (name.startsWith('.')) {
                            name = name.substr(1);
                        }
                        if (name.indexOf('.') < 0 && name !== '') {
                            _this.renderTargets[name] = slot;
                        }
                    }));
                }
                if (this.mySlots) {
                    this.mySlots.toArray().forEach(( /**
                     * @param {?} slot
                     * @return {?}
                     */function (slot) {
                        _this.renderTargets[slot.mwFieldName] = slot;
                    }));
                }
            };
        // noinspection JSUnusedGlobalSymbols
        // noinspection JSUnusedGlobalSymbols
        /**
         * @param {?} a
         * @param {?} b
         * @return {?}
         */
        AbstractFormGroupComponent.prototype.orderAsGiven =
            // noinspection JSUnusedGlobalSymbols
            /**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */
            function (a, b) {
                return a || b ? 1 : 0;
            };
        AbstractFormGroupComponent.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        AbstractFormGroupComponent.ctorParameters = function () {
            return [
                { type: core.ComponentFactoryResolver },
                { type: core.ChangeDetectorRef }
            ];
        };
        AbstractFormGroupComponent.propDecorators = {
            mwElement: [{ type: core.Input }],
            mySlots: [{ type: core.ViewChildren, args: [FormSlotDirective,] }]
        };
        return AbstractFormGroupComponent;
    }(AbstractFormFieldComponent));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/abstract-layout/abstract-layout.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // noinspection JSUnusedGlobalSymbols
    /**
     * @abstract
     * @template FormType
     */
    var  
    // noinspection JSUnusedGlobalSymbols
    /**
     * @abstract
     * @template FormType
     */
    AbstractLayoutComponent = /** @class */ (function (_super) {
        __extends(AbstractLayoutComponent, _super);
        function AbstractLayoutComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return AbstractLayoutComponent;
    }(AbstractFormGroupComponent));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/form-group/form-group.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormGroupType = /** @class */ (function (_super) {
        __extends(FormGroupType, _super);
        function FormGroupType() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.component = FormGroupComponent;
            return _this;
        }
        return FormGroupType;
    }(AbstractGroupType));
    var FormGroupComponent = /** @class */ (function (_super) {
        __extends(FormGroupComponent, _super);
        function FormGroupComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        FormGroupComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'mw-form-group',
                        template: "\n    <ng-content></ng-content>\n    <ng-container *ngFor=\"let field of mwFieldType.options.model | keyvalue:orderAsGiven\">\n      <ng-container mwFormField\n                    *ngIf=\"renderTargets[field.key] == null\"\n                    [mwFormGroup]=\"mwElement\"\n                    [mwElement]=\"elements[field.key]\"\n                    [mwFieldType]=\"field.value\"\n                    [mwPath]=\"fieldPaths[field.key]\"\n                    [mwIndex]=\"indexFromParent\"\n                    [mwSlots]=\"mwSlots\">\n      </ng-container>\n    </ng-container>\n  "
                    }] }
        ];
        return FormGroupComponent;
    }(AbstractFormGroupComponent));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/form-builder/form-builder.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var FormBuilderComponent = /** @class */ (function () {
        function FormBuilderComponent() {
            this.mwFormSubmit = new core.EventEmitter();
        }
        /**
         * @return {?}
         */
        FormBuilderComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                if (this.group == null) {
                    this.rebuildForm();
                }
            };
        /**
         * @param {?} changes
         * @return {?}
         */
        FormBuilderComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
            function (changes) {
                if ('mwFormModel' in changes && changes.mwFormModel.currentValue) {
                    this.rebuildForm();
                    this.fieldType = new FormGroupType({
                        model: this.mwFormModel,
                    });
                    Object.assign(this.fieldType, {
                        builderInstance: this,
                        component: FormGroupComponent,
                        control: this.group,
                    });
                }
                if ('mwFormData' in changes && changes.mwFormData.currentValue) {
                    if (!('mwFormModel' in changes)) {
                        this.initializeCollectionFields(this.group, this.mwFormModel, this.mwFormData);
                        this.group.initHandler.setIsInitialized(false);
                        this.group.initHandler.setIsInitialized(true);
                    }
                    if (this.group) {
                        this.group.patchValue(this.mwFormData);
                    }
                }
            };
        /**
         * @return {?}
         */
        FormBuilderComponent.prototype.rebuildForm = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var res = null;
                /** @type {?} */
                var groupIsInitialized = false;
                if (this.group) {
                    res = Object.assign({}, this.group.value);
                    groupIsInitialized = this.group.initHandler.isInitialized;
                }
                else if (this.mwFormData) {
                    res = Object.assign({}, this.mwFormData);
                }
                this.group = ModelHandler.build(this.mwFormModel, this);
                this.initializeCollectionFields(this.group, this.mwFormModel, res);
                if (this.group && res) {
                    if (groupIsInitialized) {
                        this.group.initHandler.setIsInitialized(true);
                    }
                    this.group.patchValue(res);
                }
            };
        /**
         * @private
         * @param {?} group
         * @param {?} model
         * @param {?} data
         * @return {?}
         */
        FormBuilderComponent.prototype.initializeCollectionFields = /**
         * @private
         * @param {?} group
         * @param {?} model
         * @param {?} data
         * @return {?}
         */
            function (group, model, data) {
                var _this = this;
                Object.keys(model).forEach(( /**
                 * @param {?} name
                 * @return {?}
                 */function (name) {
                    /** @type {?} */
                    var formType = model[name];
                    /** @type {?} */
                    var childData = (data && name in data) ? data[name] : null;
                    /** @type {?} */
                    var control = group.get(name);
                    if (formType instanceof AbstractGroupType && control instanceof FormGroup) {
                        _this.initializeCollectionFields(control, formType.options.model, childData);
                    }
                    else if (formType instanceof AbstractLayoutType) {
                        _this.initializeCollectionFields(group, formType.options.model, data);
                    }
                    else if (formType instanceof AbstractCollectionType && control instanceof FormArray) {
                        _this.initializeCollectionField(formType, control, childData);
                    }
                }));
            };
        /**
         * @private
         * @param {?} collection
         * @param {?} array
         * @param {?=} data
         * @return {?}
         */
        FormBuilderComponent.prototype.initializeCollectionField = /**
         * @private
         * @param {?} collection
         * @param {?} array
         * @param {?=} data
         * @return {?}
         */
            function (collection, array, data) {
                /** @type {?} */
                var numberOfEntries = Array.isArray(data) ? data.length : 0;
                array.controls.splice(0, array.controls.length);
                if (numberOfEntries === 0) {
                    return;
                }
                /** @type {?} */
                var fieldInstance = collection.fieldInstance;
                for (var i = 0; i < numberOfEntries; i++) {
                    /** @type {?} */
                    var control = ModelHandler.buildSingleField(fieldInstance, this);
                    if (!control) {
                        continue;
                    }
                    if (fieldInstance instanceof AbstractGroupType && control instanceof FormGroup) {
                        control.setParent(array);
                        if (fieldInstance.disabled) {
                            control.disable();
                        }
                        this.initializeCollectionFields(control, fieldInstance.options.model, data[i]);
                    }
                    else if (fieldInstance instanceof AbstractCollectionType && control instanceof FormArray) {
                        control.setParent(array);
                        if (fieldInstance.disabled) {
                            control.disable();
                        }
                        this.initializeCollectionField(fieldInstance, control, data[i]);
                    }
                    array.controls.push(control);
                }
            };
        /**
         * @return {?}
         */
        FormBuilderComponent.prototype.submit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                Object.keys(this.group.controls).forEach(( /**
                 * @param {?} field
                 * @return {?}
                 */function (field) {
                    /** @type {?} */
                    var control = _this.group.get(field);
                    control.markAsDirty();
                    control.updateValueAndValidity();
                }));
                if (!this.group.valid) {
                    return;
                }
                this.mwFormSubmit.emit(this.group.value);
                return this.group.value;
            };
        /**
         * @param {?=} group
         * @return {?}
         */
        FormBuilderComponent.prototype.getErrors = /**
         * @param {?=} group
         * @return {?}
         */
            function (group) {
                var _this = this;
                /** @type {?} */
                var errors = group instanceof FormArray ? [] : {};
                if (group == null) {
                    group = this.group;
                }
                /** @type {?} */
                var idx = 0;
                Object.keys(group.controls).forEach(( /**
                 * @param {?} name
                 * @return {?}
                 */function (name) {
                    idx++;
                    /** @type {?} */
                    var control = group.get(name);
                    if (control instanceof FormArray || control instanceof FormGroup) {
                        /** @type {?} */
                        var tmpErrors = _this.getErrors(control);
                        if (tmpErrors) {
                            errors[name] = tmpErrors;
                        }
                    }
                    else if (control instanceof FormControl) {
                        if (control.errors == null) {
                            return null;
                        }
                        if (group instanceof FormArray) {
                            (( /** @type {?} */(errors)))[idx] = control.errors;
                        }
                        else {
                            errors[name] = control.errors;
                        }
                    }
                }));
                return (group instanceof FormGroup && Object.keys(errors).length === 0)
                    || Array.isArray(errors) && errors.length === 0 ? null : errors;
            };
        FormBuilderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'mw-form-builder',
                        template: "\n    <ng-content></ng-content>\n    <form [formGroup]=\"group\" (ngSubmit)=\"submit()\">\n      <mw-form-group [mwElement]=\"group\"\n                     [mwFormGroup]=\"group\"\n                     [mwFieldType]=\"fieldType\"\n                     [mwSlots]=\"mwSlots\">\n      </mw-form-group>\n    </form>\n  "
                    }] }
        ];
        FormBuilderComponent.propDecorators = {
            mwFormModel: [{ type: core.Input }],
            mwFormData: [{ type: core.Input }],
            mwFormSubmit: [{ type: core.Output }],
            mwSlots: [{ type: core.ContentChildren, args: [FormSlotDirective, { descendants: true },] }]
        };
        return FormBuilderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/form-field/form-field.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormFieldDirective = /** @class */ (function (_super) {
        __extends(FormFieldDirective, _super);
        function FormFieldDirective(viewRef, cfr) {
            var _this = _super.call(this) || this;
            _this.viewRef = viewRef;
            _this.cfr = cfr;
            return _this;
        }
        // noinspection JSUnusedLocalSymbols
        // noinspection JSUnusedLocalSymbols
        /**
         * @param {?} changes
         * @return {?}
         */
        FormFieldDirective.prototype.ngOnChanges =
            // noinspection JSUnusedLocalSymbols
            /**
             * @param {?} changes
             * @return {?}
             */
            function (changes) {
                this.render();
            };
        /**
         * @return {?}
         */
        FormFieldDirective.prototype.render = /**
         * @return {?}
         */
            function () {
                if (this.mwFieldType == null || this.viewRef == null) {
                    return;
                }
                this.viewRef.clear();
                /** @type {?} */
                var factory = this.cfr.resolveComponentFactory(this.mwFieldType.component);
                /** @type {?} */
                var component = this.viewRef.createComponent(factory);
                /** @type {?} */
                var isGroup = this.mwFieldType instanceof AbstractGroupType;
                FieldInstanceHelper.setupFieldInstance(component.instance, {
                    mwFormGroup: isGroup ? ( /** @type {?} */(this.mwElement)) : this.mwFormGroup,
                    mwElement: this.mwElement,
                    mwFieldType: this.mwFieldType,
                    mwSlots: this.mwSlots,
                    mwPath: this.mwPath,
                    mwIndex: this.mwIndex,
                });
                component.changeDetectorRef.detectChanges();
            };
        FormFieldDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[mwFormField]',
                    },] }
        ];
        /** @nocollapse */
        FormFieldDirective.ctorParameters = function () {
            return [
                { type: core.ViewContainerRef },
                { type: core.ComponentFactoryResolver }
            ];
        };
        return FormFieldDirective;
    }(AbstractFormFieldComponent));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/form-builder.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormBuilderModule = /** @class */ (function () {
        function FormBuilderModule() {
        }
        FormBuilderModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            FormBuilderComponent,
                            FormGroupComponent,
                            FormFieldDirective,
                            FormSlotDirective,
                        ],
                        entryComponents: [
                            FormGroupComponent,
                        ],
                        imports: [
                            ng.ReactiveFormsModule,
                            common.CommonModule,
                        ],
                        exports: [
                            FormBuilderComponent,
                            FormGroupComponent,
                            FormFieldDirective,
                            FormSlotDirective,
                        ],
                    },] }
        ];
        return FormBuilderModule;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: mw-form-builder.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.AbstractCollectionComponent = AbstractCollectionComponent;
    exports.AbstractFormFieldComponent = AbstractFormFieldComponent;
    exports.AbstractFormGroupComponent = AbstractFormGroupComponent;
    exports.AbstractLayoutComponent = AbstractLayoutComponent;
    exports.FormBuilderComponent = FormBuilderComponent;
    exports.FormFieldDirective = FormFieldDirective;
    exports.FormSlotDirective = FormSlotDirective;
    exports.FormBuilderModule = FormBuilderModule;
    exports.AbstractGroupType = AbstractGroupType;
    exports.AbstractCollectionType = AbstractCollectionType;
    exports.AbstractLayoutType = AbstractLayoutType;
    exports.AbstractType = AbstractType;
    exports.ɵa = FormGroupComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=mw-form-builder.umd.js.map