import { Input, Directive, ViewContainerRef, SimpleChange, ChangeDetectorRef, ComponentFactoryResolver, Injectable, ViewChildren, Component, ContentChildren, EventEmitter, Output, NgModule } from '@angular/core';
import { FormGroup, ReactiveFormsModule, FormArray, FormControl } from '@angular/forms';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstract-form-field/abstract-form-field.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template T
 */
class AbstractFormFieldComponent {
}
AbstractFormFieldComponent.propDecorators = {
    mwFormGroup: [{ type: Input }],
    mwElement: [{ type: Input }],
    mwIndex: [{ type: Input }],
    mwFieldType: [{ type: Input }],
    mwPath: [{ type: Input }],
    mwSlots: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-type/abstract-type.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template T
 */
class AbstractType {
    /**
     * @param {?} options
     */
    constructor(options) {
        this.options = options;
    }
    /**
     * @return {?}
     */
    get asyncValidators() {
        return null;
    }
    /**
     * @return {?}
     */
    get validators() {
        return null;
    }
    /**
     * @return {?}
     */
    get updateOn() {
        return null;
    }
    /**
     * @return {?}
     */
    get disabled() {
        return false;
    }
    /**
     * @return {?}
     */
    get controlOptions() {
        return {
            asyncValidators: this.asyncValidators,
            validators: this.validators,
            updateOn: this.updateOn
        };
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-type/abstract-collection-type.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template TConfig, T
 */
class AbstractCollectionType extends AbstractType {
    // noinspection TypeScriptAbstractClassConstructorCanBeMadeProtected
    /**
     * @param {?} childType
     * @param {?} options
     */
    constructor(childType, options) {
        super(options);
        this.childType = childType;
        this.fieldInstance = new this.childType(this.options.entrySettings);
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-type/abstract-group-type.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template T
 */
class AbstractGroupType extends AbstractType {
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstraction/init-handler.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 */
class InitHandler {
    /**
     * @param {?} instance
     */
    constructor(instance) {
        this.instance = instance;
        this.propIsInitialized = false;
    }
    /**
     * @return {?}
     */
    get isInitialized() {
        return this.propIsInitialized;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    setIsInitialized(value) {
        /** @type {?} */
        const isGroupOrArray = 'controls' in this.instance;
        this.propIsInitialized = value;
        if (isGroupOrArray) {
            ((/** @type {?} */ ((/** @type {?} */ (this.instance)))))._setUpControls();
        }
        this.instance.updateValueAndValidity({ onlySelf: false, emitEvent: true });
        if (isGroupOrArray) {
            /** @type {?} */
            const childControls = ((/** @type {?} */ (this.instance))).controls;
            Object.keys(childControls)
                .forEach((/**
             * @param {?} k
             * @return {?}
             */
            (k) => childControls[k].initHandler.setIsInitialized(value)));
        }
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstraction/form-array.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormArray$1 extends FormArray {
    constructor() {
        super(...arguments);
        this.initHandler = new InitHandler(this);
    }
    /**
     * @param {?=} opts
     * @return {?}
     */
    updateValueAndValidity(opts) {
        if (this.initHandler && this.initHandler.isInitialized) {
            super.updateValueAndValidity(opts);
        }
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstraction/form-control.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormControl$1 extends FormControl {
    constructor() {
        super(...arguments);
        this.initHandler = new InitHandler(this);
    }
    /**
     * @param {?=} opts
     * @return {?}
     */
    updateValueAndValidity(opts) {
        if (this.initHandler && this.initHandler.isInitialized) {
            super.updateValueAndValidity(opts);
        }
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstraction/form-group.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormGroup$1 extends FormGroup {
    constructor() {
        super(...arguments);
        this.initHandler = new InitHandler(this);
    }
    /**
     * @param {?=} opts
     * @return {?}
     */
    updateValueAndValidity(opts) {
        if (this.initHandler && this.initHandler.isInitialized) {
            super.updateValueAndValidity(opts);
        }
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstraction/index.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-type/abstract-layout-type.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template T
 */
class AbstractLayoutType extends AbstractGroupType {
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/model-handler.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ModelHandler {
    /**
     * @param {?} model
     * @param {?} builderInstance
     * @return {?}
     */
    static build(model, builderInstance) {
        /** @type {?} */
        const group = new FormGroup$1({});
        this.handleModel(model, group, builderInstance);
        return group;
    }
    /**
     * @private
     * @param {?} model
     * @param {?} group
     * @param {?} builderInstance
     * @return {?}
     */
    static handleModel(model, group, builderInstance) {
        Object.keys(model).forEach((/**
         * @param {?} name
         * @return {?}
         */
        (name) => {
            /** @type {?} */
            const field = model[name];
            if (!field) {
                return;
            }
            if (field instanceof AbstractLayoutType) {
                this.handleModel(field.options.model, group, builderInstance);
                return;
            }
            /** @type {?} */
            const control = ModelHandler.buildSingleField(field, builderInstance);
            if (!control) {
                return;
            }
            control.setParent(group);
            if (field.disabled) {
                control.disable();
            }
            group.addControl(name, control);
            if (field.builderInstance == null && builderInstance) {
                field.builderInstance = builderInstance;
            }
            field.control = control;
        }));
    }
    /**
     * @param {?} field
     * @param {?} builderInstance
     * @return {?}
     */
    static buildSingleField(field, builderInstance) {
        /** @type {?} */
        let component;
        if (field instanceof AbstractCollectionType) {
            component = new FormArray$1([], field.controlOptions);
            ModelHandler.handleArray(field, component, builderInstance);
        }
        else if (field instanceof AbstractGroupType) {
            component = new FormGroup$1({}, field.controlOptions);
            ModelHandler.handleModel(field.options.model, component, builderInstance);
        }
        else if (field instanceof AbstractLayoutType) ;
        else if (field instanceof AbstractType) {
            component = new FormControl$1({ value: null, disabled: field.disabled }, field.controlOptions);
        }
        return component;
    }
    /**
     * @private
     * @param {?} field
     * @param {?} array
     * @param {?} builderInstance
     * @return {?}
     */
    static handleArray(field, array, builderInstance) {
        /** @type {?} */
        const control = ModelHandler.buildSingleField(field.fieldInstance, builderInstance);
        if (!control) {
            return;
        }
        array.push(control);
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstract-collection/abstract-collection.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// noinspection JSUnusedGlobalSymbols
/**
 * @abstract
 */
class AbstractCollectionComponent extends AbstractFormFieldComponent {
    // noinspection JSUnusedGlobalSymbols
    /**
     * @param {?} index
     * @return {?}
     */
    removeEntry(index) {
        this.mwElement.removeAt(index);
    }
    // noinspection JSUnusedGlobalSymbols
    /**
     * @return {?}
     */
    addEntry() {
        /** @type {?} */
        const newControl = ModelHandler.buildSingleField(this.mwFieldType.fieldInstance, this.mwFieldType.builderInstance);
        if (!newControl) {
            return;
        }
        newControl.initHandler.setIsInitialized(true);
        this.mwElement.controls.push(newControl);
    }
}
AbstractCollectionComponent.propDecorators = {
    mwElement: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-slot/form-slot.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormSlotDirective {
    /**
     * @param {?} viewRef
     */
    constructor(viewRef) {
        this.viewRef = viewRef;
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        if (this.renderFn) {
            this.renderFn(this.viewRef);
        }
    }
    /**
     * @param {?} renderFunction
     * @return {?}
     */
    setup(renderFunction) {
        this.renderFn = renderFunction;
        if (this.viewRef) {
            this.ngAfterViewInit();
        }
    }
}
FormSlotDirective.decorators = [
    { type: Directive, args: [{
                selector: '[mwFormSlot]',
                exportAs: 'mwFormSlot',
            },] }
];
/** @nocollapse */
FormSlotDirective.ctorParameters = () => [
    { type: ViewContainerRef }
];
FormSlotDirective.propDecorators = {
    mwFieldName: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/field-instance-helper.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FieldInstanceHelper {
    /**
     * @param {?} instance
     * @param {?} data
     * @return {?}
     */
    static setupFieldInstance(instance, data) {
        /** @type {?} */
        const changes = {
            mwFormGroup: new SimpleChange(null, data.mwFormGroup, true),
            mwElement: new SimpleChange(null, data.mwElement, true),
            mwFieldType: new SimpleChange(null, data.mwFieldType, true),
            mwSlots: new SimpleChange(null, data.mwSlots, true),
            mwPath: new SimpleChange(null, data.mwPath, true),
            mwIndex: new SimpleChange(null, data.mwIndex, true),
        };
        instance.mwFormGroup = changes.mwFormGroup.currentValue;
        instance.mwElement = changes.mwElement.currentValue;
        instance.mwFieldType = changes.mwFieldType.currentValue;
        instance.mwSlots = changes.mwSlots.currentValue;
        instance.mwPath = changes.mwPath.currentValue;
        instance.mwIndex = changes.mwIndex.currentValue;
        if ('ngOnChanges' in instance) {
            ((/** @type {?} */ (instance))).ngOnChanges(changes);
        }
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstract-form-group/abstract-form-group.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// noinspection JSUnusedGlobalSymbols
/**
 * @abstract
 * @template FormType
 */
class AbstractFormGroupComponent extends AbstractFormFieldComponent {
    /**
     * @param {?} cfr
     * @param {?} cdr
     */
    constructor(cfr, cdr) {
        super();
        this.cfr = cfr;
        this.cdr = cdr;
        this.groupPath = '';
        this.indexFromParent = null;
        this.fieldPaths = {};
        this.elements = {};
        this.renderTargets = {};
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        /** @type {?} */
        const mwPath = 'mwPath' in changes ? changes.mwPath.currentValue : this.mwPath;
        if ('mwPath' in changes) {
            this.groupPath = (mwPath == null || mwPath.trim() === '')
                ? ''
                : mwPath;
        }
        /** @type {?} */
        const mwFieldType = 'mwFieldType' in changes ? changes.mwFieldType.currentValue : this.mwFieldType;
        if ('mwPath' in changes || 'mwFieldType' in changes) {
            this.fieldPaths = Object.keys(mwFieldType.options.model).reduce((/**
             * @param {?} all
             * @param {?} fieldName
             * @return {?}
             */
            (all, fieldName) => {
                if (mwFieldType.options.model[fieldName] instanceof AbstractLayoutType) {
                    all[fieldName] = mwPath;
                }
                else {
                    all[fieldName] = (this.groupPath !== '' ? this.groupPath + '.' : '') + fieldName;
                }
                return all;
            }), {});
        }
        if ('mwIndex' in changes) {
            /** @type {?} */
            const mwIndex = changes.mwIndex.currentValue;
            this.indexFromParent = null;
            if (mwIndex != null) {
                /** @type {?} */
                let p = this.mwElement;
                do {
                    p = p.parent;
                    if (p instanceof FormArray$1) {
                        this.indexFromParent = this.mwIndex;
                        break;
                    }
                } while (p && p.parent && !(parent instanceof FormControl$1));
            }
        }
        this.elements = Object.keys(mwFieldType.options.model).reduce((/**
         * @param {?} all
         * @param {?} fieldName
         * @return {?}
         */
        (all, fieldName) => {
            if (mwFieldType.options.model[fieldName] instanceof AbstractLayoutType) {
                all[fieldName] = this.mwElement;
            }
            else {
                all[fieldName] = this.mwElement.get(fieldName);
            }
            return all;
        }), {});
        /** @type {?} */
        let wasRendered = false;
        if ('mwSlots' in changes && changes.mwSlots.currentValue) {
            this.renderElementsInSlots();
            wasRendered = true;
        }
        if (!wasRendered && 'mySlots' in changes && changes.mySlots.currentValue) {
            this.renderElementsInSlots();
        }
    }
    /**
     * @return {?}
     */
    ngAfterContentInit() {
        if (this.mySlots) {
            this.renderElementsInSlots();
            this.cdr.detectChanges();
        }
    }
    /**
     * @private
     * @return {?}
     */
    renderElementsInSlots() {
        if (!(this.mwSlots || this.mySlots)) {
            return;
        }
        this.createRenderTargets();
        Object.keys(this.renderTargets).forEach((/**
         * @param {?} name
         * @return {?}
         */
        (name) => {
            if (!(name in this.renderTargets)) {
                return;
            }
            this.renderTargets[name].setup((/**
             * @param {?} viewRef
             * @return {?}
             */
            (viewRef) => {
                viewRef.clear();
                /** @type {?} */
                const factory = this.cfr.resolveComponentFactory(this.mwFieldType.options.model[name].component);
                /** @type {?} */
                const component = viewRef.createComponent(factory);
                /** @type {?} */
                const isGroup = this.mwFieldType.options.model[name] instanceof AbstractGroupType;
                FieldInstanceHelper.setupFieldInstance(component.instance, {
                    mwFormGroup: isGroup ? this.elements[name] : this.mwFormGroup,
                    mwElement: this.elements[name],
                    mwFieldType: this.mwFieldType.options.model[name],
                    mwSlots: this.mwSlots,
                    mwPath: this.fieldPaths[name],
                    mwIndex: this.indexFromParent,
                });
            }));
        }));
        this.mwElement.initHandler.setIsInitialized(true);
        this.cdr.detectChanges();
    }
    /**
     * @private
     * @return {?}
     */
    createRenderTargets() {
        /** @type {?} */
        const groupPath = this.groupPath;
        if (this.mwSlots) {
            this.mwSlots.toArray().forEach((/**
             * @param {?} slot
             * @return {?}
             */
            (slot) => {
                if (slot.mwFieldName.substr(0, groupPath.length) !== groupPath) {
                    return;
                }
                /** @type {?} */
                let name = slot.mwFieldName.substr(groupPath.length, slot.mwFieldName.length - groupPath.length);
                if (name.startsWith('.')) {
                    name = name.substr(1);
                }
                if (name.indexOf('.') < 0 && name !== '') {
                    this.renderTargets[name] = slot;
                }
            }));
        }
        if (this.mySlots) {
            this.mySlots.toArray().forEach((/**
             * @param {?} slot
             * @return {?}
             */
            (slot) => {
                this.renderTargets[slot.mwFieldName] = slot;
            }));
        }
    }
    // noinspection JSUnusedGlobalSymbols
    /**
     * @param {?} a
     * @param {?} b
     * @return {?}
     */
    orderAsGiven(a, b) {
        return a || b ? 1 : 0;
    }
}
AbstractFormGroupComponent.decorators = [
    { type: Injectable }
];
/** @nocollapse */
AbstractFormGroupComponent.ctorParameters = () => [
    { type: ComponentFactoryResolver },
    { type: ChangeDetectorRef }
];
AbstractFormGroupComponent.propDecorators = {
    mwElement: [{ type: Input }],
    mySlots: [{ type: ViewChildren, args: [FormSlotDirective,] }]
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/abstract-layout/abstract-layout.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// noinspection JSUnusedGlobalSymbols
/**
 * @abstract
 * @template FormType
 */
class AbstractLayoutComponent extends AbstractFormGroupComponent {
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-group/form-group.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormGroupType extends AbstractGroupType {
    constructor() {
        super(...arguments);
        this.component = FormGroupComponent;
    }
}
class FormGroupComponent extends AbstractFormGroupComponent {
}
FormGroupComponent.decorators = [
    { type: Component, args: [{
                selector: 'mw-form-group',
                template: `
    <ng-content></ng-content>
    <ng-container *ngFor="let field of mwFieldType.options.model | keyvalue:orderAsGiven">
      <ng-container mwFormField
                    *ngIf="renderTargets[field.key] == null"
                    [mwFormGroup]="mwElement"
                    [mwElement]="elements[field.key]"
                    [mwFieldType]="field.value"
                    [mwPath]="fieldPaths[field.key]"
                    [mwIndex]="indexFromParent"
                    [mwSlots]="mwSlots">
      </ng-container>
    </ng-container>
  `
            }] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-builder/form-builder.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 */
class FormBuilderComponent {
    constructor() {
        this.mwFormSubmit = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        if (this.group == null) {
            this.rebuildForm();
        }
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        if ('mwFormModel' in changes && changes.mwFormModel.currentValue) {
            this.rebuildForm();
            this.fieldType = new FormGroupType({
                model: this.mwFormModel,
            });
            Object.assign(this.fieldType, {
                builderInstance: this,
                component: FormGroupComponent,
                control: this.group,
            });
        }
        if ('mwFormData' in changes && changes.mwFormData.currentValue) {
            if (!('mwFormModel' in changes)) {
                this.initializeCollectionFields(this.group, this.mwFormModel, this.mwFormData);
                this.group.initHandler.setIsInitialized(false);
                this.group.initHandler.setIsInitialized(true);
            }
            if (this.group) {
                this.group.patchValue(this.mwFormData);
            }
        }
    }
    /**
     * @return {?}
     */
    rebuildForm() {
        /** @type {?} */
        let res = null;
        /** @type {?} */
        let groupIsInitialized = false;
        if (this.group) {
            res = Object.assign({}, this.group.value);
            groupIsInitialized = this.group.initHandler.isInitialized;
        }
        else if (this.mwFormData) {
            res = Object.assign({}, this.mwFormData);
        }
        this.group = ModelHandler.build(this.mwFormModel, this);
        this.initializeCollectionFields(this.group, this.mwFormModel, res);
        if (this.group && res) {
            if (groupIsInitialized) {
                this.group.initHandler.setIsInitialized(true);
            }
            this.group.patchValue(res);
        }
    }
    /**
     * @private
     * @param {?} group
     * @param {?} model
     * @param {?} data
     * @return {?}
     */
    initializeCollectionFields(group, model, data) {
        Object.keys(model).forEach((/**
         * @param {?} name
         * @return {?}
         */
        (name) => {
            /** @type {?} */
            const formType = model[name];
            /** @type {?} */
            const childData = (data && name in data) ? data[name] : null;
            /** @type {?} */
            const control = group.get(name);
            if (formType instanceof AbstractGroupType && control instanceof FormGroup$1) {
                this.initializeCollectionFields(control, formType.options.model, childData);
            }
            else if (formType instanceof AbstractLayoutType) {
                this.initializeCollectionFields(group, formType.options.model, data);
            }
            else if (formType instanceof AbstractCollectionType && control instanceof FormArray$1) {
                this.initializeCollectionField(formType, control, childData);
            }
        }));
    }
    /**
     * @private
     * @param {?} collection
     * @param {?} array
     * @param {?=} data
     * @return {?}
     */
    initializeCollectionField(collection, array, data) {
        /** @type {?} */
        const numberOfEntries = Array.isArray(data) ? data.length : 0;
        array.controls.splice(0, array.controls.length);
        if (numberOfEntries === 0) {
            return;
        }
        /** @type {?} */
        const fieldInstance = collection.fieldInstance;
        for (let i = 0; i < numberOfEntries; i++) {
            /** @type {?} */
            const control = ModelHandler.buildSingleField(fieldInstance, this);
            if (!control) {
                continue;
            }
            if (fieldInstance instanceof AbstractGroupType && control instanceof FormGroup$1) {
                control.setParent(array);
                if (fieldInstance.disabled) {
                    control.disable();
                }
                this.initializeCollectionFields(control, fieldInstance.options.model, data[i]);
            }
            else if (fieldInstance instanceof AbstractCollectionType && control instanceof FormArray$1) {
                control.setParent(array);
                if (fieldInstance.disabled) {
                    control.disable();
                }
                this.initializeCollectionField(fieldInstance, control, data[i]);
            }
            array.controls.push(control);
        }
    }
    /**
     * @return {?}
     */
    submit() {
        Object.keys(this.group.controls).forEach((/**
         * @param {?} field
         * @return {?}
         */
        (field) => {
            /** @type {?} */
            const control = this.group.get(field);
            control.markAsDirty();
            control.updateValueAndValidity();
        }));
        if (!this.group.valid) {
            return;
        }
        this.mwFormSubmit.emit(this.group.value);
        return this.group.value;
    }
    /**
     * @param {?=} group
     * @return {?}
     */
    getErrors(group) {
        /** @type {?} */
        const errors = group instanceof FormArray$1 ? [] : {};
        if (group == null) {
            group = this.group;
        }
        /** @type {?} */
        let idx = 0;
        Object.keys(group.controls).forEach((/**
         * @param {?} name
         * @return {?}
         */
        (name) => {
            idx++;
            /** @type {?} */
            const control = group.get(name);
            if (control instanceof FormArray$1 || control instanceof FormGroup$1) {
                /** @type {?} */
                const tmpErrors = this.getErrors(control);
                if (tmpErrors) {
                    errors[name] = tmpErrors;
                }
            }
            else if (control instanceof FormControl$1) {
                if (control.errors == null) {
                    return null;
                }
                if (group instanceof FormArray$1) {
                    ((/** @type {?} */ (errors)))[idx] = control.errors;
                }
                else {
                    errors[name] = control.errors;
                }
            }
        }));
        return (group instanceof FormGroup$1 && Object.keys(errors).length === 0)
            || Array.isArray(errors) && errors.length === 0 ? null : errors;
    }
}
FormBuilderComponent.decorators = [
    { type: Component, args: [{
                selector: 'mw-form-builder',
                template: `
    <ng-content></ng-content>
    <form [formGroup]="group" (ngSubmit)="submit()">
      <mw-form-group [mwElement]="group"
                     [mwFormGroup]="group"
                     [mwFieldType]="fieldType"
                     [mwSlots]="mwSlots">
      </mw-form-group>
    </form>
  `
            }] }
];
FormBuilderComponent.propDecorators = {
    mwFormModel: [{ type: Input }],
    mwFormData: [{ type: Input }],
    mwFormSubmit: [{ type: Output }],
    mwSlots: [{ type: ContentChildren, args: [FormSlotDirective, { descendants: true },] }]
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-field/form-field.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormFieldDirective extends AbstractFormFieldComponent {
    /**
     * @param {?} viewRef
     * @param {?} cfr
     */
    constructor(viewRef, cfr) {
        super();
        this.viewRef = viewRef;
        this.cfr = cfr;
    }
    // noinspection JSUnusedLocalSymbols
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        this.render();
    }
    /**
     * @return {?}
     */
    render() {
        if (this.mwFieldType == null || this.viewRef == null) {
            return;
        }
        this.viewRef.clear();
        /** @type {?} */
        const factory = this.cfr.resolveComponentFactory(this.mwFieldType.component);
        /** @type {?} */
        const component = this.viewRef.createComponent(factory);
        /** @type {?} */
        const isGroup = this.mwFieldType instanceof AbstractGroupType;
        FieldInstanceHelper.setupFieldInstance(component.instance, {
            mwFormGroup: isGroup ? (/** @type {?} */ (this.mwElement)) : this.mwFormGroup,
            mwElement: this.mwElement,
            mwFieldType: this.mwFieldType,
            mwSlots: this.mwSlots,
            mwPath: this.mwPath,
            mwIndex: this.mwIndex,
        });
        component.changeDetectorRef.detectChanges();
    }
}
FormFieldDirective.decorators = [
    { type: Directive, args: [{
                selector: '[mwFormField]',
            },] }
];
/** @nocollapse */
FormFieldDirective.ctorParameters = () => [
    { type: ViewContainerRef },
    { type: ComponentFactoryResolver }
];

/**
 * @fileoverview added by tsickle
 * Generated from: lib/form-builder.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormBuilderModule {
}
FormBuilderModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    FormBuilderComponent,
                    FormGroupComponent,
                    FormFieldDirective,
                    FormSlotDirective,
                ],
                entryComponents: [
                    FormGroupComponent,
                ],
                imports: [
                    ReactiveFormsModule,
                    CommonModule,
                ],
                exports: [
                    FormBuilderComponent,
                    FormGroupComponent,
                    FormFieldDirective,
                    FormSlotDirective,
                ],
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: lib/types.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: mw-form-builder.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AbstractCollectionComponent, AbstractFormFieldComponent, AbstractFormGroupComponent, AbstractLayoutComponent, FormBuilderComponent, FormFieldDirective, FormSlotDirective, FormBuilderModule, AbstractGroupType, AbstractCollectionType, AbstractLayoutType, AbstractType, FormGroupComponent as ɵa };

//# sourceMappingURL=mw-form-builder.js.map