import { AbstractFormFieldComponent } from '../abstract-form-field/abstract-form-field.component';
import { AbstractGroupType, IGroupTypeOptions } from '../form-type/abstract-group-type';
import { KeyValue } from '@angular/common';
import { AfterContentInit, ChangeDetectorRef, ComponentFactoryResolver, OnChanges, QueryList, SimpleChanges } from '@angular/core';
import { FormGroup } from '../abstraction';
import { AbstractFormControl } from '../types';
import { FormSlotDirective } from '../form-slot/form-slot.directive';
export declare abstract class AbstractFormGroupComponent<FormType extends AbstractGroupType<IGroupTypeOptions>> extends AbstractFormFieldComponent<FormType> implements OnChanges, AfterContentInit {
    protected readonly cfr: ComponentFactoryResolver;
    protected readonly cdr: ChangeDetectorRef;
    groupPath: string;
    indexFromParent?: number;
    fieldPaths: {
        [key: string]: string;
    };
    elements: {
        [key: string]: AbstractFormControl;
    };
    mwElement: FormGroup;
    mySlots: QueryList<FormSlotDirective>;
    renderTargets: {
        [key: string]: FormSlotDirective;
    };
    constructor(cfr: ComponentFactoryResolver, cdr: ChangeDetectorRef);
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterContentInit(): void;
    private renderElementsInSlots;
    private createRenderTargets;
    orderAsGiven(a: KeyValue<string, any>, b: KeyValue<string, any>): number;
}
